<%@ Page Language="vb" AutoEventWireup="false" Inherits="Flowcharter._Default" Codebehind="Default.aspx.vb" %>

<%@ Register Assembly="MindFusion.Diagramming.WebForms" Namespace="MindFusion.Diagramming.WebForms" TagPrefix="ndiag" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
  <title>MindFusion NetDiagram Sample - FlowCharter</title>
  <link href="common/jquery-ui.min.css" rel="stylesheet" />
  <link href="common/samples.css" rel="stylesheet" />
  <script type="text/javascript" src="common/jquery.min.js"></script>
  <script type="text/javascript" src="common/jquery-ui.min.js"></script>
  <script type="text/javascript" src="common/samples.js"></script>
  <style type="text/css">
    .toolButton
    {
    	float: left;
    	width: 30px;
    	height: 30px;
    	margin: 0px;
    	text-align: center;
    	vertical-align: middle;
    	cursor: pointer;
    	background-repeat: no-repeat;
    }
    .toolButton div
    {
    	width: 16px;
    	height: 16px;
    	margin-left: 7px;
    	margin-top: 7px;
    	background-image: url('images/icons.png');
    }
    .toolButton:hover
    {
    	background-color: #cfcfcf;
    }
    .toolSelect
    {
    	height: 30px;
    }
    .toolSeparator
    {
    	float: left;
    	width: 1px;
    	height: 30px;
    	margin: 0px 2px;
    	background-color: #e2e4e7;
    }
  </style>
</head>
<body>
<form id="form1" runat="server">
  <asp:ScriptManager ID="ScriptManager1" runat="server" />

  <div id="header" style="height: 49px;">
    <div style="float: left; margin-right: 5px; margin-top: 4px;">
      <asp:TextBox ID="tbFileName" runat="server" style="height 18px;">untitled.fc</asp:TextBox>
    </div>
    <div style="float: left; margin-right: 5px;">
      <asp:Button ID="btnSave" runat="server" Text="Save" OnClick="btnSave_Click" style="height: 28px;" />
    </div>
    <div style="float: left; margin-right: 5px; margin-top: 2px;">
      <span style="font-size: 18px; font-weight: bold;">&rarr;</span>
    </div>
    <div style="float: left; margin-right: 5px;">
      <asp:DropDownList ID="listFileNames" runat="server" style="height: 24px;"></asp:DropDownList>
    </div>
    <div style="float: left; margin-right: 5px;">
      <asp:Button ID="btnLoad" runat="server" Text="Load" OnClick="btnLoad_Click" style="height: 28px;" />
    </div>
    <div style="float: right; margin-right: 5px; margin-top: 17px;">
      <button id="expandButton" onclick="onExpandCollapse()">&gt;</button>
    </div>
  </div>

  <div id="info" style="top: 60px; bottom: 24px;">
    <div id="infoTab" style="padding: 10px;">
      <h1>About this sample</h1>
      <p>This sample illustrates a ready-to-use application for drawing flowcharts. The sample initially displays a diagram created in code. You can use the buttons in the toolbar in order to adjust various properties of the diagram. New items can be created by dragging them from the shape list on the left. The flowcharts can be saved and loaded through the controls at the top of the page.</p>
    </div>
  </div>

  <div id="content" style="top: 60px; bottom: 24px;">
    <div style="position: absolute; left: 0px; top: 0px; bottom: 0px; width: 200px; border-right: 1px solid #e2e4e7; overflow: hidden;">
      <ndiag:Overview ID="ivw" runat="server" DiagramViewID="diagramView" ClientSideMode="Canvas" style="position: absolute; top: 0px; bottom: 0px; right: 0px; width: 200px; height: 200px; border-bottom: 1px solid #e2e4e7;"></ndiag:Overview>
      <ndiag:ShapeListBox ID="shapeList" runat="server" ClientSideMode="Canvas" style="position: absolute; top: 201px; left: 0px; right: 0px; bottom: 0px; width: 200px; overflow: auto; background-color: #fafafa;" Width="0" Height="0" ShapeSelectedScript="onShapeSelected" ShapeFillColor="#CCD3D7" />
    </div>

    <div style="position: absolute; left: 201px; top: 0px; right: 0px; bottom: 0px;">
      <div style="position: absolute; left: 0px; top: 0px; right: 0px; height: 32px; background-color: #fafafa; border-bottom: 1px solid #e2e4e7; border-right: 1px solid #e2e4e7;">
        <div style="overflow: hidden; height: 100%; margin: 1px; padding: 0px;">
          <div class="toolButton" onclick="onUndo()" title="Undo"><div style="background-position: 0px 0px;"></div></div>
          <div class="toolButton" onclick="onRedo()" title="Redo"><div style="background-position: -16px 0px;"></div></div>
          <div class="toolButton" onclick="onDelete()" title="Delete"><div style="background-position: -32px 0px;"></div></div>
          <div class="toolSeparator"></div>
          <div class="toolButton" onclick="onZoomIn()" title="Zoom In"><div style="background-position: -48px 0px;"></div></div>
          <div class="toolButton" onclick="onZoomOut()" title="Zoom Out"><div style="background-position: -64px 0px;"></div></div>
          <div class="toolButton" onclick="onResetZoom()" title="No Zoom"><div style="background-position: -80px 0px;"></div></div>
          <div class="toolSeparator"></div>
          <div style="float: left; padding-top: 1px;">
            <select id="fontName" class="toolSelect" style="width: 100px;">
              <option>Arial</option>
              <option>Courier New</option>
              <option>Georgia</option>
              <option>Times New Roman</option>
              <option>Trebuchet MS</option>
              <option>Verdana</option>
            </select>
          </div>
          <div style="float: left; padding-top: 1px;">
            <select id="fontSize" class="toolSelect" style="width: 50px;">
              <option>2</option>
              <option>3</option>
              <option selected="selected">4</option>
              <option>5</option>
              <option>6</option>
              <option>7</option>
              <option>8</option>
              <option>9</option>
            </select>
          </div>
          <div class="toolButton" onclick="onBold()" title="Bold"><div style="background-position: -96px 0px;"></div></div>
          <div class="toolButton" onclick="onItalic()" title="Italic"><div style="background-position: -112px 0px;"></div></div>
          <div class="toolButton" onclick="onUnderlined()" title="Underlined"><div style="background-position: -128px 0px;"></div></div>
          <div class="toolSeparator"></div>
          <div class="toolButton" onclick="onLeft()" title="Left"><div style="background-position: 0px -16px;"></div></div>
          <div class="toolButton" onclick="onCenter()" title="Center"><div style="background-position: -16px -16px;"></div></div>
          <div class="toolButton" onclick="onRight()" title="Right"><div style="background-position: -32px -16px;"></div></div>
          <div class="toolButton" onclick="onTop()" title="Top"><div style="background-position: -48px -16px;"></div></div>
          <div class="toolButton" onclick="onMiddle()" title="Middle"><div style="background-position: -64px -16px;"></div></div>
          <div class="toolButton" onclick="onBottom()" title="Bottom"><div style="background-position: -80px -16px;"></div></div>
          <div class="toolSeparator"></div>
          <div class="toolButton" onclick="onLinkShapes()" title="Link Shapes"><div style="background-position: -112px -16px;"></div></div>
          <div class="toolButton" onclick="onLinkTables()" title="Link Tables"><div style="background-position: -128px -16px;"></div></div>
          <div class="toolButton" onclick="onModify()" title="Modify"><div style="background-position: 0px -32px;"></div></div>
        </div>
      </div>
      <ndiag:DiagramView ID="diagramView" runat="server" style="position: absolute; left: 0px; top: 33px; right: 0px; bottom: 0px;"
			  ClientSideMode="Canvas"
			  JsLibraryLocation="Scripts/MindFusion.Diagramming.js"
        AppletStartedScript="onLoaded"
			  NodeCreatedScript="onNodeCreated"
        LinkCreatingScript="onLinkCreated"
        NodeSelectedScript="onNodeSelected"
        NodeDeselectedScript="onNodeSelected"
			  AllowInplaceEdit="true"
			  Diagram-RouteLinks="true" />
    </div>
  </div>

  <div id="footer" style="height: 24px;">
    <span id="copyright"></span>
  </div>

</form>
    
<script type="text/javascript">
  var AnchorPattern = MindFusion.Diagramming.AnchorPattern;
  var AnchorPoint = MindFusion.Diagramming.AnchorPoint;
  var DiagramNode = MindFusion.Diagramming.DiagramNode;
  var ShapeNode = MindFusion.Diagramming.ShapeNode;
  var MarkStyle = MindFusion.Diagramming.MarkStyle;
  var Style = MindFusion.Diagramming.Style;
  var Theme = MindFusion.Diagramming.Theme;
  var FontStyle = MindFusion.Drawing.FontStyle;
  var Alignment = MindFusion.Diagramming.Alignment;
  var Behavior = MindFusion.Diagramming.Behavior;
  var HandlesStyle = MindFusion.Diagramming.HandlesStyle;
  var ChangeItemCommand = MindFusion.Diagramming.ChangeItemCommand;

  var diagram;

  function onShapeSelected(sender, e) {
    var selectedNode = e.getNode();
    if (selectedNode)
      diagram.setDefaultShape(selectedNode.getShape());
  }

  var anchorPattern;

  function onLoaded(sender) {
    diagram = sender;
    diagram.setUndoEnabled(true);
    diagram.setRoundedLinks(true);

    anchorPattern = new AnchorPattern([
      new AnchorPoint(50, 0, true, false, MarkStyle.Rectangle, "#ff0000", 1.5),
      new AnchorPoint(0, 50, false, true, MarkStyle.Rectangle, "#008000", 1.5),
      new AnchorPoint(100, 50, false, true, MarkStyle.Rectangle, "#008000", 1.5),
      new AnchorPoint(50, 100, false, true, MarkStyle.Rectangle, "#008000", 1.5)
    ]);

    for (var i = 0; i < diagram.nodes.length; i++)
      diagram.nodes[i].setAnchorPattern(anchorPattern);

    for (var i = 0; i < diagram.links.length; i++)
    {
      var link = diagram.links[i];
      link.setHeadShape("Triangle");
      link.setHeadShapeSize(3);
    }

    var theme = new Theme();
    var shapeNodeStyle = new Style();
    shapeNodeStyle.setBrush({ type: 'LinearGradientBrush', color1: '#FCFCFC', color2: '#9DABB4', angle: 90 });
    shapeNodeStyle.setStroke("#7F7F7F");
    shapeNodeStyle.setTextColor("#585A5C");
    shapeNodeStyle.setFontName("Verdana");
    shapeNodeStyle.setFontSize(3);
    theme.styles["std:ShapeNode"] = shapeNodeStyle;
    var linkStyle = new Style();
    linkStyle.setStroke("#7F7F7F");
    linkStyle.setTextColor("#585A5C");
    linkStyle.setFontName("Verdana");
    linkStyle.setFontSize(3);
    theme.styles["std:DiagramLink"] = linkStyle;
    var tableStyle = new Style();
    tableStyle.setBrush({ type: 'LinearGradientBrush', color1: '#FCFCFC', color2: '#9DABB4', angle: 90 });
    tableStyle.setStroke("#7F7F7F");
    tableStyle.setTextColor("#585A5C");
    tableStyle.setFontName("Verdana");
    tableStyle.setFontSize(3);
    theme.styles["std:TableNode"] = tableStyle;
    diagram.setTheme(theme);

    var original = DiagramNode.prototype.createAnchorPointVisual;
    ShapeNode.prototype.createAnchorPointVisual = function (point)
    {
      var result = original.apply(this, [point]);
      result.brush = point.getColor();
      result.pen = '#7F7F7F';
      return result;
    };

    diagram.routeAllLinks();
  }

  function onNodeCreated(sender, args) {
    var node = args.getNode();
    node.setBrush(); // Reset brush
    node.setAnchorPattern(anchorPattern);
    node.setHandlesStyle(HandlesStyle.HatchHandles3);
  }

  function onLinkCreated(sender, args) {
    var link = args.getLink();
    link.setHeadShape("Triangle");
    link.setHeadShapeSize(3);
  }

  function onNodeSelected(sender, args) {
  	var node;
  	diagram = sender;
    if (diagram.getSelection().nodes.length > 0)
      node = diagram.getSelection().nodes[0];
    if (node && node.getStyle() !== undefined) {
      var style = node.getStyle();
      if (style.getFontName())
        $('#fontName').val(style.getFontName());
      else
        $('#fontName').val('Verdana');
      if (style.getFontSize())
        $('#fontSize').val(style.getFontSize());
      else
        $('#fontSize').val('3');
      $("#fontName").selectmenu("refresh");
      $("#fontSize").selectmenu("refresh");
    }
    else {
      $('#fontName').val('Verdana');
      $('#fontSize').val('3');
      $("#fontName").selectmenu("refresh");
      $("#fontSize").selectmenu("refresh");
    }
  }

  function onUndo() {
    diagram.undo();
  }

  function onRedo() {
    diagram.redo();
  }

  function onDelete() {
    diagram.startCompositeOperation();
    for (var i = diagram.getSelection().items.length - 1; i >= 0; i--) {
      diagram.removeItem(diagram.getSelection().items[i]);
    }
    diagram.commitCompositeOperation();
  }

  function onZoomIn() {
    diagram.setZoomFactor(Math.min(800, diagram.getZoomFactor() + 10));
  }

  function onZoomOut() {
    diagram.setZoomFactor(Math.max(10, diagram.getZoomFactor() - 10));
  }

  function onResetZoom() {
    diagram.setZoomFactor(100);
  }

  $('#fontName').on("selectmenuchange", function () {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);

      var style = item.getStyle();
      if (!style) {
        style = new Style();
        item.setStyle(style);
      }

      style.setFontName(this.value);
      item.invalidate();

      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  });

  $('#fontSize').on("selectmenuchange", function () {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);

      var style = item.getStyle();
      if (!style) {
        style = new Style();
        item.setStyle(style);
      }

      style.setFontSize(this.value);
      item.invalidate();

      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  });

  function onBold() {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);

      var style = item.getStyle();
      if (!style) {
        style = new Style();
        item.setStyle(style);
      }

      if (style.getFontStyle() === undefined) {
        style.setFontStyle(FontStyle.Bold);
      }
      else if ((style.getFontStyle() & FontStyle.Bold) != FontStyle.Bold) {
        style.setFontStyle(style.getFontStyle() | FontStyle.Bold);
      }
      else {
        style.setFontStyle(style.getFontStyle() & ~FontStyle.Bold);
      }

      item.invalidate();

      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  }

  function onItalic() {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);

      var style = item.getStyle();
      if (!style) {
        style = new Style();
        item.setStyle(style);
      }

      if (style.getFontStyle() === undefined) {
        style.setFontStyle(FontStyle.Italic);
      }
      else if ((style.getFontStyle() & FontStyle.Italic) != FontStyle.Italic) {
        style.setFontStyle(style.getFontStyle() | FontStyle.Italic);
      }
      else {
        style.setFontStyle(style.getFontStyle() & ~FontStyle.Italic);
      }

      item.invalidate();

      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  }

  function onUnderlined() {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);

      var style = item.getStyle();
      if (!style) {
        style = new Style();
        item.setStyle(style);
      }

      if (style.getFontStyle() === undefined) {
        style.setFontStyle(FontStyle.Underline);
      }
      else if ((style.getFontStyle() & FontStyle.Underline) != FontStyle.Underline) {
        style.setFontStyle(style.getFontStyle() | FontStyle.Underline);
      }
      else {
        style.setFontStyle(style.getFontStyle() & ~FontStyle.Underline);
      }

      item.invalidate();

      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  }

  function onLeft() {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);
      item.setTextAlignment(Alignment.Near);
      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  }

  function onCenter() {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);
      item.setTextAlignment(Alignment.Center);
      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  }

  function onRight() {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);
      item.setTextAlignment(Alignment.Far);
      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  }

  function onTop() {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);
      item.setLineAlignment(Alignment.Near);
      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  }

  function onMiddle() {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);
      item.setLineAlignment(Alignment.Center);
      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  }

  function onBottom() {
    diagram.startCompositeOperation();
    for (var i = 0; i < diagram.getSelection().items.length; i++) {
      var item = diagram.getSelection().items[i];
      var change = new ChangeItemCommand(diagram, item);
      item.setLineAlignment(Alignment.Far);
      diagram.executeCommand(change);
    }
    diagram.commitCompositeOperation();
  }

  function onLinkShapes() {
    diagram.setBehavior(Behavior.LinkShapes);
  }

  function onLinkTables() {
    diagram.setBehavior(Behavior.LinkTables);
  }

  function onModify() {
    diagram.setBehavior(Behavior.Modify);
  }
</script>
</body>
</html>
