Imports System.IO

Imports MindFusion.Diagramming

Partial Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		If (Not IsPostBack) Then

			Dim diagram As Diagram = diagramView.Diagram
			diagram.SelectAfterCreate = False
			diagram.ShowGrid = True
			diagram.ShapeHandlesStyle = HandlesStyle.HatchHandles3

			' Create a sample diagram
			Dim start As ShapeNode = diagram.Factory.CreateShapeNode(60, 8, 32, 16)
			start.Shape = Shapes.Terminator
			start.Text = "Start"

			Dim choice As ShapeNode = diagram.Factory.CreateShapeNode(60, 36, 32, 16)
			choice.Shape = Shapes.Decision
			choice.Text = "Choice"

			Dim input As ShapeNode = diagram.Factory.CreateShapeNode(108, 36, 32, 16)
			input.Shape = Shapes.Save
			input.Text = "Data input"

			Dim user As ShapeNode = diagram.Factory.CreateShapeNode(136, 36, 16, 16)
			user.Shape = Shapes.Actor

			Dim process As ShapeNode = diagram.Factory.CreateShapeNode(60, 64, 32, 16)
			process.Shape = Shapes.Procedure
			process.Text = "Predefined process/routing"

			Dim document1 As ShapeNode = diagram.Factory.CreateShapeNode(8, 64, 16, 16)
			document1.Shape = Shapes.Document
			document1.Text = "Document"

			Dim document2 As ShapeNode = diagram.Factory.CreateShapeNode(32, 64, 16, 16)
			document2.Shape = Shapes.Document
			document2.Text = "Document"

			Dim multiDocument As ShapeNode = diagram.Factory.CreateShapeNode(8, 92, 16, 16)
			multiDocument.Shape = Shapes.MultiDocument
			multiDocument.Text = "Multiple documents"

			Dim database As ShapeNode = diagram.Factory.CreateShapeNode(32, 92, 16, 16)
			database.Shape = Shapes.Database
			database.Text = "Database"

			Dim procedure As ShapeNode = diagram.Factory.CreateShapeNode(60, 92, 32, 16)
			procedure.Text = "Alternative procedure"

			Dim delay As ShapeNode = diagram.Factory.CreateShapeNode(108, 92, 32, 16)
			delay.Shape = Shapes.Delay
			delay.Text = "Delay"

			Dim [end] As ShapeNode = diagram.Factory.CreateShapeNode(60, 120, 32, 16)
			[end].Shape = Shapes.Terminator
			[end].Text = "End"

			Diagram.Factory.CreateDiagramLink(start, choice)
			Diagram.Factory.CreateDiagramLink(choice, Process)
			Diagram.Factory.CreateDiagramLink(choice, Input)
			Diagram.Factory.CreateDiagramLink(choice, 3, document1, 0)
			Diagram.Factory.CreateDiagramLink(choice, 3, document2, 0)
			Diagram.Factory.CreateDiagramLink(document1, multiDocument)
			Diagram.Factory.CreateDiagramLink(document2, database)
			Diagram.Factory.CreateDiagramLink(Process, procedure)
			Diagram.Factory.CreateDiagramLink(procedure, delay)
			diagram.Factory.CreateDiagramLink(procedure, [end])

		End If
	End Sub

    Protected Overloads Overrides Sub OnPreRender(ByVal e As System.EventArgs)
        MyBase.OnPreRender(e)
        ' display the files available for loading
        listFileNames.Items.Clear()
        Dim localDir As String = MapPath("Files\")
        Dim dir As DirectoryInfo = New DirectoryInfo(localDir)
        For Each fileInfo As FileInfo In dir.GetFiles()
            listFileNames.Items.Add(fileInfo.Name)
        Next
    End Sub

    Protected Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If Not String.IsNullOrEmpty(tbFileName.Text) Then
            Dim localDir As String = MapPath("Files\")
            diagramView.Diagram.SaveToFile(localDir + tbFileName.Text)
        End If
    End Sub

    Protected Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
        If Not String.IsNullOrEmpty(listFileNames.SelectedValue) Then
            Dim localDir As String = MapPath("Files\")
            diagramView.Diagram.LoadFromFile(localDir + listFileNames.SelectedValue)
        End If
    End Sub
End Class